-- noqa: disable=all
-- This sql was autogenerated as a reference example using the library
-- CLI. Its format is tied to the specific database it was run against,
-- and it may not be correct for all databases. Use the CLI's build 
-- option to derive the best SQL for your dataset.

-- ###########################################################

CREATE TABLE core__encounter_dn_type AS (
    WITH

    system_type_0 AS (
        SELECT DISTINCT
            s.id AS id,
            '0' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://terminology.hl7.org/CodeSystem/encounter-type'
    ), --noqa: LT07

    system_type_1 AS (
        SELECT DISTINCT
            s.id AS id,
            '1' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://terminology.hl7.org/CodeSystem/v2-0004'
    ), --noqa: LT07

    system_type_2 AS (
        SELECT DISTINCT
            s.id AS id,
            '2' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'urn:oid:2.16.840.1.113883.4.642.3.248'
    ), --noqa: LT07

    system_type_3 AS (
        SELECT DISTINCT
            s.id AS id,
            '3' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://snomed.info/sct'
    ), --noqa: LT07

    system_type_4 AS (
        SELECT DISTINCT
            s.id AS id,
            '4' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'https://fhir.cerner.com/%/codeSet/71'
    ), --noqa: LT07

    system_type_5 AS (
        SELECT DISTINCT
            s.id AS id,
            '5' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'urn:oid:1.2.840.114350.1.13.71.2.7.10.698084.10110'
    ), --noqa: LT07

    system_type_6 AS (
        SELECT DISTINCT
            s.id AS id,
            '6' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'urn:oid:1.2.840.114350.1.13.71.2.7.10.698084.18875'
    ), --noqa: LT07

    system_type_7 AS (
        SELECT DISTINCT
            s.id AS id,
            '7' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'urn:oid:1.2.840.114350.1.13.71.2.7.10.698084.30'
    ), --noqa: LT07

    system_type_8 AS (
        SELECT DISTINCT
            s.id AS id,
            '8' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.type) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'urn:oid:1.2.840.114350.1.13.71.2.7.2.808267'
    ), --noqa: LT07

    union_table AS (
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_0
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_1
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_2
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_3
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_4
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_5
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_6
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_7
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_type_8
        
    ),

    partitioned_table AS (
        SELECT
            id,
            code,
            code_system,
            display,
            priority,
            ROW_NUMBER()
                OVER (
                    PARTITION BY id
                    ORDER BY priority ASC
                ) AS available_priority
        FROM union_table
        GROUP BY id, priority, code_system, code, display
        ORDER BY priority ASC
    )

    SELECT
        id,
        code,
        code_system,
        display
    FROM partitioned_table
    WHERE available_priority = 1
);


-- ###########################################################

CREATE TABLE IF NOT EXISTS "main"."core__encounter_dn_servicetype"
AS (
    SELECT * FROM (
        VALUES
        (cast(NULL AS varchar),cast(NULL AS varchar),cast(NULL AS varchar),cast(NULL AS varchar))
    )
        AS t ("id","code","code_system","display")
);

-- ###########################################################

CREATE TABLE IF NOT EXISTS "main"."core__encounter_dn_priority"
AS (
    SELECT * FROM (
        VALUES
        (cast(NULL AS varchar),cast(NULL AS varchar),cast(NULL AS varchar),cast(NULL AS varchar))
    )
        AS t ("id","code","code_system","display")
);

-- ###########################################################

CREATE TABLE core__encounter_dn_reasoncode AS (
    WITH

    system_reasoncode_0 AS (
        SELECT DISTINCT
            s.id AS id,
            '0' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.reasoncode) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://terminology.hl7.org/CodeSystem/v3-ActPriority'
    ), --noqa: LT07

    system_reasoncode_1 AS (
        SELECT DISTINCT
            s.id AS id,
            '1' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.reasoncode) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://snomed.info/sct'
    ), --noqa: LT07

    system_reasoncode_2 AS (
        SELECT DISTINCT
            s.id AS id,
            '2' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.reasoncode) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://hl7.org/fhir/sid/icd-10-cm'
    ), --noqa: LT07

    system_reasoncode_3 AS (
        SELECT DISTINCT
            s.id AS id,
            '3' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.reasoncode) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'http://hl7.org/fhir/sid/icd-9-cm'
    ), --noqa: LT07

    system_reasoncode_4 AS (
        SELECT DISTINCT
            s.id AS id,
            '4' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.reasoncode) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'https://fhir.cerner.com/%/nomenclature'
    ), --noqa: LT07

    system_reasoncode_5 AS (
        SELECT DISTINCT
            s.id AS id,
            '5' AS priority,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.reasoncode) AS cc (cc_row),
            UNNEST(cc.cc_row.coding) AS u (codeable_concept)
        WHERE
            u.codeable_concept.system LIKE 'urn:oid:1.2.840.114350.1.13.71.2.7.2.728286'
    ), --noqa: LT07

    union_table AS (
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_reasoncode_0
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_reasoncode_1
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_reasoncode_2
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_reasoncode_3
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_reasoncode_4
        UNION
        SELECT
            id,
            priority,
            code_system,
            code,
            display
        FROM system_reasoncode_5
        
    ),

    partitioned_table AS (
        SELECT
            id,
            code,
            code_system,
            display,
            priority,
            ROW_NUMBER()
                OVER (
                    PARTITION BY id
                    ORDER BY priority ASC
                ) AS available_priority
        FROM union_table
        GROUP BY id, priority, code_system, code, display
        ORDER BY priority ASC
    )

    SELECT
        id,
        code,
        code_system,
        display
    FROM partitioned_table
    WHERE available_priority = 1
);


-- ###########################################################

CREATE TABLE core__encounter_dn_dischargedisposition AS (
    WITH

    system_dischargedisposition_0 AS (
        SELECT DISTINCT
            s.id AS id,
            u.codeable_concept.code,
            u.codeable_concept.display,
            u.codeable_concept.system AS code_system
        FROM
            encounter AS s,
            UNNEST(s.hospitalization.dischargedisposition.coding) AS u (codeable_concept)
    ), --noqa: LT07

    union_table AS (
        SELECT
            id,
            code_system,
            code,
            display
        FROM system_dischargedisposition_0
        
    )
    SELECT
        id,
        code,
        code_system,
        display
    FROM union_table
);


-- ###########################################################

CREATE TABLE core__encounter AS
WITH temp_encounter_nullable AS (
    SELECT DISTINCT
        e.id,
        e.status,
        e.class,
        e.subject.reference AS subject_ref,
        e.period,
        date(from_iso8601_timestamp(e.period.start)) AS period_start,
        date_trunc('day', date(from_iso8601_timestamp(e."period"."end")))
            AS period_end_day,
        date_trunc('day', date(from_iso8601_timestamp(e."period"."start")))
            AS period_start_day,
        date_trunc('week', date(from_iso8601_timestamp(e."period"."start")))
            AS period_start_week,
        date_trunc('month', date(from_iso8601_timestamp(e."period"."start")))
            AS period_start_month,
        date_trunc('year', date(from_iso8601_timestamp(e."period"."start")))
            AS period_start_year
    FROM encounter AS e
),

temp_encounter AS (
    SELECT DISTINCT
        e.id,
        e.status,
        e.class,
        e.subject_ref,
        e.period_start,
        e.period_start_day,
        e.period_end_day,
        e.period_start_week,
        e.period_start_month,
        e.period_start_year,
        edt.code AS type_code,
        edt.code_system AS type_code_system,
        edt.display AS type_display,
        eds.code AS seviceType_code,
        eds.code_system AS seviceType_code_system,
        eds.display AS serviceType_display,
        edp.code AS priority_code,
        edp.code_system AS priority_code_system,
        edp.display AS priority_display,
        edr.code AS reasonCode_code,
        edr.code_system AS reasonCode_code_system,
        edr.display AS reasonCode_display,
        edd.code AS dischargeDisposition_code,
        edd.code_system AS dischargeDisposition_code_system,
        edd.display AS dischargeDisposition_display

    FROM temp_encounter_nullable AS e
    LEFT JOIN core__encounter_dn_priority AS edt ON e.id = edt.id
    LEFT JOIN core__encounter_dn_servicetype AS eds ON e.id = eds.id
    LEFT JOIN core__encounter_dn_priority AS edp ON e.id = edp.id
    LEFT JOIN core__encounter_dn_reasonCode AS edr ON e.id = edr.id
    LEFT JOIN core__encounter_dn_dischargeDisposition AS edd ON e.id = edd.id
)

SELECT DISTINCT
    e.id,
    e.status,
    ac.code AS class_code,
    ac.display AS class_display,
    e.type_code,
    e.type_code_system,
    e.type_display,
    e.seviceType_code,
    e.seviceType_code_system,
    e.serviceType_display,
    e.priority_code,
    e.priority_code_system,
    e.priority_display,
    e.reasonCode_code,
    e.reasonCode_code_system,
    e.reasonCode_display,
    e.dischargeDisposition_code,
    e.dischargeDisposition_code_system,
    e.dischargeDisposition_display,
    date_diff('year', date(p.birthdate), e.period_start_day) AS age_at_visit,
    p.gender,
    p.race_display,
    p.ethnicity_display,
    p.postalcode_3,
    e.period_start_day,
    coalesce(e.period_end_day, e.period_start_day) AS period_end_day,
    e.period_start_week AS period_start_week,
    e.period_start_month AS period_start_month,
    e.period_start_year AS period_start_year,
    e.subject_ref,
    concat('Encounter/', e.id) AS encounter_ref
FROM temp_encounter AS e
LEFT JOIN core__fhir_mapping_expected_act_encounter_code_v3 AS eac
    ON e.class.code = eac.found
LEFT JOIN core__fhir_act_encounter_code_v3 AS ac ON eac.expected = ac.code
INNER JOIN core__patient AS p ON e.subject_ref = p.subject_ref
WHERE
    e.period_start_day BETWEEN date('2016-06-01') AND current_date;
